package xyz.pixelatedw.finalbeta.mixin;

import java.util.Random;

import org.lwjgl.input.Keyboard;
import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Inject;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfo;

import net.minecraft.client.Minecraft;
import net.minecraft.container.ChestContainer;
import net.minecraft.entity.player.ClientPlayer;
import net.minecraft.entity.player.Player;
import net.minecraft.inventory.Inventory;
import net.minecraft.item.ItemInstance;
import xyz.pixelatedw.finalbeta.ModConfig;
import xyz.pixelatedw.finalbeta.WyHelper;

@Mixin(ClientPlayer.class)
public class ClientPlayerMixin {

	private Random rand = new Random();

	@Inject(method = "method_136", at = @At("TAIL"))
	public void onKeyPressed(int key, boolean state, CallbackInfo ci) {
		Minecraft mc = WyHelper.getInstance();
		Player player = (Player) (Object) this;

		if (player.vehicle != null && key == Keyboard.KEY_LSHIFT && state) {
			player.startRiding(null);
			return;
		}

		if (ModConfig.STACK_DROP.get() && key == mc.options.dropKey.key && state && Keyboard.isKeyDown(Keyboard.KEY_LSHIFT)) {
			ItemInstance heldItem = player.inventory.getHeldItem();
			if (heldItem != null && heldItem.count > 0) {
				player.dropItem(player.inventory.takeInvItem(player.inventory.selectedHotbarSlot, heldItem.count), false);
				return;
			}
		}

		if (WyHelper.isDebug() && key == Keyboard.KEY_Z && state) {
			WyHelper.cheatCommand(player);
			return;
		}
	}

	@Inject(method = "openChestScreen", at = @At("TAIL"))
	public void openChestScreen(Inventory arg, CallbackInfo ci) {
		if (ModConfig.ADD_MORE_SOUNDS.get()) {
			Player player = (Player) (Object) this;
			player.level.playSound(player, "random.chestopen", 0.3f, (this.rand.nextFloat() - this.rand.nextFloat()) * 0.2F + 1.0F);
		}
	}

	@Inject(method = "closeContainer", at = @At("HEAD"))
	public void closeContainer(CallbackInfo ci) {
		if (ModConfig.ADD_MORE_SOUNDS.get()) {
			Player player = (Player) (Object) this;
			if (player.container instanceof ChestContainer) {
				player.level.playSound(player, "random.chestclosed", 0.3f, (this.rand.nextFloat() - this.rand.nextFloat()) * 0.2F + 1.0F);
			}
		}
	}
}
